## MmGdbusCall MmGdbusCall — Generated C code for the org.freedesktop.ModemManager1.Call D-Bus interface |

## Functions

gint | mm_gdbus_call_get_direction ()
const gchar * | mm_gdbus_call_get_number ()
gchar * | mm_gdbus_call_dup_number ()
gint | mm_gdbus_call_get_state ()
gint | mm_gdbus_call_get_state_reason ()
GVariant * | mm_gdbus_call_dup_audio_format ()
gchar * | mm_gdbus_call_dup_audio_port ()
GVariant * | mm_gdbus_call_get_audio_format ()
const gchar * | mm_gdbus_call_get_audio_port ()
gboolean | mm_gdbus_call_get_multiparty ()
void | mm_gdbus_call_call_accept ()
gboolean | mm_gdbus_call_call_accept_finish ()
gboolean | mm_gdbus_call_call_accept_sync ()
void | mm_gdbus_call_call_start ()
gboolean | mm_gdbus_call_call_start_finish ()
gboolean | mm_gdbus_call_call_start_sync ()
void | mm_gdbus_call_call_hangup ()
gboolean | mm_gdbus_call_call_hangup_finish ()
gboolean | mm_gdbus_call_call_hangup_sync ()
void | mm_gdbus_call_call_send_dtmf ()
gboolean | mm_gdbus_call_call_send_dtmf_finish ()
gboolean | mm_gdbus_call_call_send_dtmf_sync ()
void | mm_gdbus_call_call_deflect ()
gboolean | mm_gdbus_call_call_deflect_finish ()
gboolean | mm_gdbus_call_call_deflect_sync ()
void | mm_gdbus_call_call_join_multiparty ()
gboolean | mm_gdbus_call_call_join_multiparty_finish ()
gboolean | mm_gdbus_call_call_join_multiparty_sync ()
void | mm_gdbus_call_call_leave_multiparty ()
gboolean | mm_gdbus_call_call_leave_multiparty_finish ()
gboolean | mm_gdbus_call_call_leave_multiparty_sync ()

## Properties

GVariant * | audio-format | Read / Write
char * | audio-port | Read / Write
int | direction | Read / Write
gboolean | multiparty | Read / Write
char * | number | Read / Write
int | state | Read / Write
int | state-reason | Read / Write

## Signals

void | dtmf-received | Run Last
gboolean | handle-accept | Run Last
gboolean | handle-deflect | Run Last
gboolean | handle-hangup | Run Last
gboolean | handle-join-multiparty | Run Last
gboolean | handle-leave-multiparty | Run Last
gboolean | handle-send-dtmf | Run Last
gboolean | handle-start | Run Last
void | state-changed | Run Last

## Types and Values

| MmGdbusCall
struct | MmGdbusCallIface

## Object Hierarchy

        GInterface
        ╰── MmGdbusCall

## Prerequisites

MmGdbusCall requires GObject.

## Known Implementations

MmGdbusCall is implemented by MMCall, MmGdbusCallProxy and MmGdbusCallSkeleton.

## Description

This section contains code for working with the org.freedesktop.ModemManager1.Call D-Bus interface in C.

## Functions

### mm_gdbus_call_get_direction ()

    gint
    mm_gdbus_call_get_direction (MmGdbusCall *object);

Gets the value of the "Direction" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusCall. |

#### Returns

The property value.

### mm_gdbus_call_get_number ()

    const gchar *
    mm_gdbus_call_get_number (MmGdbusCall *object);

Gets the value of the "Number" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `mm_gdbus_call_dup_number()` if on another thread.

[skip]

#### Parameters

object | A MmGdbusCall. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none][nullable]

### mm_gdbus_call_dup_number ()

    gchar *
    mm_gdbus_call_dup_number (MmGdbusCall *object);

Gets a copy of the "Number" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusCall. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_free()`.

[transfer full][nullable]

### mm_gdbus_call_get_state ()

    gint
    mm_gdbus_call_get_state (MmGdbusCall *object);

Gets the value of the "State" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusCall. |

#### Returns

The property value.

### mm_gdbus_call_get_state_reason ()

    gint
    mm_gdbus_call_get_state_reason (MmGdbusCall *object);

Gets the value of the "StateReason" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusCall. |

#### Returns

The property value.

### mm_gdbus_call_dup_audio_format ()

    GVariant *
    mm_gdbus_call_dup_audio_format (MmGdbusCall *object);

Gets a copy of the "AudioFormat" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusCall. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_variant_unref()`.

[transfer full][nullable]

### mm_gdbus_call_dup_audio_port ()

    gchar *
    mm_gdbus_call_dup_audio_port (MmGdbusCall *object);

Gets a copy of the "AudioPort" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusCall. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_free()`.

[transfer full][nullable]

### mm_gdbus_call_get_audio_format ()

    GVariant *
    mm_gdbus_call_get_audio_format (MmGdbusCall *object);

Gets the value of the "AudioFormat" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `mm_gdbus_call_dup_audio_format()` if on another thread.

[skip]

#### Parameters

object | A MmGdbusCall. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none][nullable]

### mm_gdbus_call_get_audio_port ()

    const gchar *
    mm_gdbus_call_get_audio_port (MmGdbusCall *object);

Gets the value of the "AudioPort" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `mm_gdbus_call_dup_audio_port()` if on another thread.

[skip]

#### Parameters

object | A MmGdbusCall. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none][nullable]

### mm_gdbus_call_get_multiparty ()

    gboolean
    mm_gdbus_call_get_multiparty (MmGdbusCall *object);

Gets the value of the "Multiparty" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusCall. |

#### Returns

The property value.

### mm_gdbus_call_call_accept ()

    void
    mm_gdbus_call_call_accept (MmGdbusCall *proxy,
                               GCancellable *cancellable,
                               GAsyncReadyCallback callback,
                               gpointer user_data);

Asynchronously invokes the `Accept()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_call_call_accept_finish()` to get the result of the operation.

See `mm_gdbus_call_call_accept_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusCallProxy. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_call_call_accept_finish ()

    gboolean
    mm_gdbus_call_call_accept_finish (MmGdbusCall *proxy,
                                      GAsyncResult *res,
                                      GError **error);

Finishes an operation started with `mm_gdbus_call_call_accept()`.

#### Parameters

proxy | A MmGdbusCallProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_call_call_accept()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_call_call_accept_sync ()

    gboolean
    mm_gdbus_call_call_accept_sync (MmGdbusCall *proxy,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `Accept()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_call_call_accept()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusCallProxy. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_call_call_start ()

    void
    mm_gdbus_call_call_start (MmGdbusCall *proxy,
                              GCancellable *cancellable,
                              GAsyncReadyCallback callback,
                              gpointer user_data);

Asynchronously invokes the `Start()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_call_call_start_finish()` to get the result of the operation.

See `mm_gdbus_call_call_start_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusCallProxy. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_call_call_start_finish ()

    gboolean
    mm_gdbus_call_call_start_finish (MmGdbusCall *proxy,
                                     GAsyncResult *res,
                                     GError **error);

Finishes an operation started with `mm_gdbus_call_call_start()`.

#### Parameters

proxy | A MmGdbusCallProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_call_call_start()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_call_call_start_sync ()

    gboolean
    mm_gdbus_call_call_start_sync (MmGdbusCall *proxy,
                                   GCancellable *cancellable,
                                   GError **error);

Synchronously invokes the `Start()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_call_call_start()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusCallProxy. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_call_call_hangup ()

    void
    mm_gdbus_call_call_hangup (MmGdbusCall *proxy,
                               GCancellable *cancellable,
                               GAsyncReadyCallback callback,
                               gpointer user_data);

Asynchronously invokes the `Hangup()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_call_call_hangup_finish()` to get the result of the operation.

See `mm_gdbus_call_call_hangup_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusCallProxy. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_call_call_hangup_finish ()

    gboolean
    mm_gdbus_call_call_hangup_finish (MmGdbusCall *proxy,
                                      GAsyncResult *res,
                                      GError **error);

Finishes an operation started with `mm_gdbus_call_call_hangup()`.

#### Parameters

proxy | A MmGdbusCallProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_call_call_hangup()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_call_call_hangup_sync ()

    gboolean
    mm_gdbus_call_call_hangup_sync (MmGdbusCall *proxy,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `Hangup()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_call_call_hangup()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusCallProxy. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_call_call_send_dtmf ()

    void
    mm_gdbus_call_call_send_dtmf (MmGdbusCall *proxy,
                                  const gchar *arg_dtmf,
                                  GCancellable *cancellable,
                                  GAsyncReadyCallback callback,
                                  gpointer user_data);

Asynchronously invokes the `SendDtmf()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_call_call_send_dtmf_finish()` to get the result of the operation.

See `mm_gdbus_call_call_send_dtmf_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusCallProxy. |
arg_dtmf | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_call_call_send_dtmf_finish ()

    gboolean
    mm_gdbus_call_call_send_dtmf_finish (MmGdbusCall *proxy,
                                         GAsyncResult *res,
                                         GError **error);

Finishes an operation started with `mm_gdbus_call_call_send_dtmf()`.

#### Parameters

proxy | A MmGdbusCallProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_call_call_send_dtmf()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_call_call_send_dtmf_sync ()

    gboolean
    mm_gdbus_call_call_send_dtmf_sync (MmGdbusCall *proxy,
                                       const gchar *arg_dtmf,
                                       GCancellable *cancellable,
                                       GError **error);

Synchronously invokes the `SendDtmf()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_call_call_send_dtmf()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusCallProxy. |
arg_dtmf | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_call_call_deflect ()

    void
    mm_gdbus_call_call_deflect (MmGdbusCall *proxy,
                                const gchar *arg_number,
                                GCancellable *cancellable,
                                GAsyncReadyCallback callback,
                                gpointer user_data);

Asynchronously invokes the `Deflect()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_call_call_deflect_finish()` to get the result of the operation.

See `mm_gdbus_call_call_deflect_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusCallProxy. |
arg_number | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_call_call_deflect_finish ()

    gboolean
    mm_gdbus_call_call_deflect_finish (MmGdbusCall *proxy,
                                       GAsyncResult *res,
                                       GError **error);

Finishes an operation started with `mm_gdbus_call_call_deflect()`.

#### Parameters

proxy | A MmGdbusCallProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_call_call_deflect()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_call_call_deflect_sync ()

    gboolean
    mm_gdbus_call_call_deflect_sync (MmGdbusCall *proxy,
                                     const gchar *arg_number,
                                     GCancellable *cancellable,
                                     GError **error);

Synchronously invokes the `Deflect()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_call_call_deflect()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusCallProxy. |
arg_number | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_call_call_join_multiparty ()

    void
    mm_gdbus_call_call_join_multiparty (MmGdbusCall *proxy,
                                        GCancellable *cancellable,
                                        GAsyncReadyCallback callback,
                                        gpointer user_data);

Asynchronously invokes the `JoinMultiparty()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_call_call_join_multiparty_finish()` to get the result of the operation.

See `mm_gdbus_call_call_join_multiparty_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusCallProxy. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_call_call_join_multiparty_finish ()

    gboolean
    mm_gdbus_call_call_join_multiparty_finish
                                   (MmGdbusCall *proxy,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `mm_gdbus_call_call_join_multiparty()`.

#### Parameters

proxy | A MmGdbusCallProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_call_call_join_multiparty()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_call_call_join_multiparty_sync ()

    gboolean
    mm_gdbus_call_call_join_multiparty_sync
                                   (MmGdbusCall *proxy,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `JoinMultiparty()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_call_call_join_multiparty()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusCallProxy. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_call_call_leave_multiparty ()

    void
    mm_gdbus_call_call_leave_multiparty (MmGdbusCall *proxy,
                                         GCancellable *cancellable,
                                         GAsyncReadyCallback callback,
                                         gpointer user_data);

Asynchronously invokes the `LeaveMultiparty()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_call_call_leave_multiparty_finish()` to get the result of the operation.

See `mm_gdbus_call_call_leave_multiparty_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusCallProxy. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_call_call_leave_multiparty_finish ()

    gboolean
    mm_gdbus_call_call_leave_multiparty_finish
                                   (MmGdbusCall *proxy,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `mm_gdbus_call_call_leave_multiparty()`.

#### Parameters

proxy | A MmGdbusCallProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_call_call_leave_multiparty()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_call_call_leave_multiparty_sync ()

    gboolean
    mm_gdbus_call_call_leave_multiparty_sync
                                   (MmGdbusCall *proxy,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `LeaveMultiparty()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_call_call_leave_multiparty()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusCallProxy. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

## Types and Values

### MmGdbusCall

    typedef struct _MmGdbusCall MmGdbusCall;

Abstract interface type for the D-Bus interface org.freedesktop.ModemManager1.Call.

### struct MmGdbusCallIface

    struct MmGdbusCallIface {
      GTypeInterface parent_iface;

      gboolean (*handle_accept) (
        MmGdbusCall *object,
        GDBusMethodInvocation *invocation);

      gboolean (*handle_deflect) (
        MmGdbusCall *object,
        GDBusMethodInvocation *invocation,
        const gchar *arg_number);

      gboolean (*handle_hangup) (
        MmGdbusCall *object,
        GDBusMethodInvocation *invocation);

      gboolean (*handle_join_multiparty) (
        MmGdbusCall *object,
        GDBusMethodInvocation *invocation);

      gboolean (*handle_leave_multiparty) (
        MmGdbusCall *object,
        GDBusMethodInvocation *invocation);

      gboolean (*handle_send_dtmf) (
        MmGdbusCall *object,
        GDBusMethodInvocation *invocation,
        const gchar *arg_dtmf);

      gboolean (*handle_start) (
        MmGdbusCall *object,
        GDBusMethodInvocation *invocation);

      GVariant * (*get_audio_format) (MmGdbusCall *object);

      const gchar * (*get_audio_port) (MmGdbusCall *object);

      gint  (*get_direction) (MmGdbusCall *object);

      gboolean  (*get_multiparty) (MmGdbusCall *object);

      const gchar * (*get_number) (MmGdbusCall *object);

      gint  (*get_state) (MmGdbusCall *object);

      gint  (*get_state_reason) (MmGdbusCall *object);

      void (*dtmf_received) (
        MmGdbusCall *object,
        const gchar *arg_dtmf);

      void (*state_changed) (
        MmGdbusCall *object,
        gint arg_old,
        gint arg_new,
        guint arg_reason);
    };

Virtual table for the D-Bus interface org.freedesktop.ModemManager1.Call.

#### Members

GTypeInterface `parent_iface`; | The parent interface. |
`handle_accept` () | Handler for the “handle-accept” signal. |
`handle_deflect` () | Handler for the “handle-deflect” signal. |
`handle_hangup` () | Handler for the “handle-hangup” signal. |
`handle_join_multiparty` () | Handler for the “handle-join-multiparty” signal. |
`handle_leave_multiparty` () | Handler for the “handle-leave-multiparty” signal. |
`handle_send_dtmf` () | Handler for the “handle-send-dtmf” signal. |
`handle_start` () | Handler for the “handle-start” signal. |
`get_audio_format` () | Getter for the “audio-format” property. |
`get_audio_port` () | Getter for the “audio-port” property. |
`get_direction` () | Getter for the “direction” property. |
`get_multiparty` () | Getter for the “multiparty” property. |
`get_number` () | Getter for the “number” property. |
`get_state` () | Getter for the “state” property. |
`get_state_reason` () | Getter for the “state-reason” property. |
`dtmf_received` () | Handler for the “dtmf-received” signal. |
`state_changed` () | Handler for the “state-changed” signal. |

## Property Details

### The `“audio-format”` property

      “audio-format”             GVariant *

Represents the D-Bus property "AudioFormat".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusCall

Flags: Read / Write

Allowed values: GVariant<a{sv}>

Default value: NULL

### The `“audio-port”` property

      “audio-port”               char *

Represents the D-Bus property "AudioPort".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusCall

Flags: Read / Write

Default value: NULL

### The `“direction”` property

      “direction”                int

Represents the D-Bus property "Direction".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusCall

Flags: Read / Write

Default value: 0

### The `“multiparty”` property

      “multiparty”               gboolean

Represents the D-Bus property "Multiparty".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusCall

Flags: Read / Write

Default value: FALSE

### The `“number”` property

      “number”                   char *

Represents the D-Bus property "Number".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusCall

Flags: Read / Write

Default value: NULL

### The `“state”` property

      “state”                    int

Represents the D-Bus property "State".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusCall

Flags: Read / Write

Default value: 0

### The `“state-reason”` property

      “state-reason”             int

Represents the D-Bus property "StateReason".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusCall

Flags: Read / Write

Default value: 0

## Signal Details

### The `“dtmf-received”` signal

    void
    user_function (MmGdbusCall *object,
                   char        *arg_dtmf,
                   gpointer     user_data)

On the client-side, this signal is emitted whenever the D-Bus signal "DtmfReceived" is received.

On the service-side, this signal can be used with e.g. `g_signal_emit_by_name()` to make the object emit the D-Bus signal.

#### Parameters

object | A MmGdbusCall. |
arg_dtmf | Argument. |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“handle-accept”` signal

    gboolean
    user_function (MmGdbusCall           *object,
                   GDBusMethodInvocation *invocation,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `Accept()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_call_complete_accept()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no other signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusCall. |
invocation | A GDBusMethodInvocation. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-deflect”` signal

    gboolean
    user_function (MmGdbusCall           *object,
                   GDBusMethodInvocation *invocation,
                   char                  *arg_number,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `Deflect()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_call_complete_deflect()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no other signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusCall. |
invocation | A GDBusMethodInvocation. |
arg_number | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-hangup”` signal

    gboolean
    user_function (MmGdbusCall           *object,
                   GDBusMethodInvocation *invocation,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `Hangup()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_call_complete_hangup()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no other signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusCall. |
invocation | A GDBusMethodInvocation. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-join-multiparty”` signal

    gboolean
    user_function (MmGdbusCall           *object,
                   GDBusMethodInvocation *invocation,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `JoinMultiparty()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_call_complete_join_multiparty()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no other signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusCall. |
invocation | A GDBusMethodInvocation. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-leave-multiparty”` signal

    gboolean
    user_function (MmGdbusCall           *object,
                   GDBusMethodInvocation *invocation,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `LeaveMultiparty()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_call_complete_leave_multiparty()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no other signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusCall. |
invocation | A GDBusMethodInvocation. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-send-dtmf”` signal

    gboolean
    user_function (MmGdbusCall           *object,
                   GDBusMethodInvocation *invocation,
                   char                  *arg_dtmf,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `SendDtmf()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_call_complete_send_dtmf()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no other signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusCall. |
invocation | A GDBusMethodInvocation. |
arg_dtmf | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-start”` signal

    gboolean
    user_function (MmGdbusCall           *object,
                   GDBusMethodInvocation *invocation,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `Start()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_call_complete_start()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no other signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusCall. |
invocation | A GDBusMethodInvocation. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“state-changed”` signal

    void
    user_function (MmGdbusCall *object,
                   int          arg_old,
                   int          arg_new,
                   guint        arg_reason,
                   gpointer     user_data)

On the client-side, this signal is emitted whenever the D-Bus signal "StateChanged" is received.

On the service-side, this signal can be used with e.g. `g_signal_emit_by_name()` to make the object emit the D-Bus signal.

#### Parameters

object | A MmGdbusCall. |
arg_old | Argument. |
arg_new | Argument. |
arg_reason | Argument. |
user_data | user data set when the signal handler was connected. |

Flags: Run Last